/*!
 * @file lbolt.h
 * @brief light blaster lbolt
*/

#ifndef _SPIKE_BALL_H
#define _SPIKE_BALL_H

#include "projectile.h"
#include "effects/billboard.h"
#include "../weapons/weapon.h"

class Vector;
class Weapon;
class SpriteParticles;
class ParticleEmitter;
class FastFactory;

class SpikeBall : public Projectile
{
  ObjectListDeclaration(SpikeBall);
  public:
    SpikeBall ();
    virtual ~SpikeBall ();


    virtual void activate();
    virtual void deactivate();

    virtual void collidesWith(WorldEntity* entity, const Vector& location);

    virtual void destroy (WorldEntity* killer);

    virtual void tick (float dt);
    virtual void draw () const;

//     virtual void blow();

  private:
    static FastFactory*               fastFactory;

    static SpriteParticles*           explosionParticles;

    ParticleEmitter*                  emitter;

    float                             speed;

    float                             angle;
    float                             rotationSpeed;

    Billboard*                        halo;

    WorldEntity* hitEntity; // FIXME TEMPORARY
};

#endif /* _SPIKE_BALL_H */
